<?php
include "includes/header.php";
include "check_login.php";
?>

<body>


    <!-- Page Preloder -->
    <div id="preloder">
        <div class="loader"></div>
    </div>


    <?php
    include "includes/head.php";
    ?>

    <style>
        /* Styles for the star rating */
        .star-rating i {
            font-size: 2em;
            /* Increase the size of the stars */
            margin-right: 13px;
            /* Add space between the stars */
            color: #ccc;
            /* Default color for unselected stars */
        }



        .star-rating i.fa-star.rated {
            color: var(--main-color);
            /* Color for selected stars */
        }

        #tracking {
            background: #fff
        }

        .tracking-detail {
            padding: 3rem 0;
        }

        #tracking {
            margin-bottom: 1rem;
        }

        [class*="tracking-status-"] p {
            margin: 0;
            font-size: 1.1rem;
            color: #fff;
            text-transform: uppercase;
            text-align: center;
        }

        [class*="tracking-status-"] {
            padding: 1.6rem 0;
        }

        .tracking-list {
            border: 1px solid #e5e5e5;
        }

        .tracking-item {
            border-left: 4px solid var(--main-color);
            position: relative;
            padding: 2rem 1.5rem 0.5rem 2.5rem;
            font-size: 0.9rem;
            margin-left: 3rem;
            min-height: 5rem;
        }

        @keyframes scaleAnimation {
            0% {
                transform: scale(1);
            }

            50% {
                transform: scale(1.1);
            }

            100% {
                transform: scale(1);
            }
        }

        .btn-view {
            animation: scaleAnimation 4s infinite;

        }




        .tracking-item:last-child {
            padding-bottom: 4rem;
        }

        .tracking-item .tracking-date {
            margin-bottom: 0.5rem;
        }

        .tracking-item .tracking-date span {
            color: #888;
            font-size: 85%;
            padding-left: 0.4rem;
        }

        .tracking-item .tracking-content {
            padding: 0.5rem 0.8rem;
            background-color: #f4f4f4;
            border-radius: 0.5rem;
        }

        .tracking-item .tracking-content span {
            display: block;
            color: #767676;
            font-size: 13px;
        }

        .tracking-item .tracking-icon {
            position: absolute;
            left: -0.7rem;
            width: 1.1rem;
            height: 1.1rem;
            text-align: center;
            border-radius: 50%;
            font-size: 1.1rem;
            background-color: var(--main-color);
            /* Change background color */
            color: #fff;
        }

        .tracking-item-pending {
            border-left: 4px solid #d6d6d6;
            position: relative;
            padding: 2rem 1.5rem 0.5rem 2.5rem;
            font-size: 0.9rem;
            margin-left: 3rem;
            min-height: 5rem;
        }

        .tracking-item-pending:last-child {
            padding-bottom: 4rem;
        }

        .tracking-item-pending .tracking-date {
            margin-bottom: 0.5rem;
        }

        .tracking-item-pending .tracking-date span {
            color: #888;
            font-size: 85%;
            padding-left: 0.4rem;
        }

        .tracking-item-pending .tracking-content {
            padding: 0.5rem 0.8rem;
            background-color: #f4f4f4;
            border-radius: 0.5rem;
        }

        .tracking-item-pending .tracking-content span {
            display: block;
            color: #767676;
            font-size: 13px;
        }

        .tracking-item-pending .tracking-icon {
            line-height: 2.6rem;
            position: absolute;
            left: -0.7rem;
            width: 1.1rem;
            height: 1.1rem;
            text-align: center;
            border-radius: 50%;
            font-size: 1.1rem;
            color: #d6d6d6;
        }

        .tracking-item-pending .tracking-content {
            font-weight: 600;
            font-size: 17px;
        }

        .tracking-item .tracking-icon.status-current {
            width: 1.9rem;
            height: 1.9rem;
            left: -1.1rem;
        }

        .tracking-item .tracking-icon.status-intransit {
            font-size: 0.6rem;
        }

        .tracking-item .tracking-icon.status-current {
            font-size: 0.6rem;
        }

        @media (min-width: 992px) {
            .tracking-item {
                margin-left: 10rem;
            }

            .tracking-item .tracking-date {
                position: absolute;
                left: -10rem;
                width: 7.5rem;
                text-align: right;
            }

            .tracking-item .tracking-date span {
                display: block;
            }

            .tracking-item .tracking-content {
                padding: 0;
                background-color: transparent;
            }

            .tracking-item-pending {
                margin-left: 10rem;
            }

            .tracking-item-pending .tracking-date {
                position: absolute;
                left: -10rem;
                width: 7.5rem;
                text-align: right;
            }

            .tracking-item-pending .tracking-date span {
                display: block;
            }

            .tracking-item-pending .tracking-content {
                padding: 0;
                background-color: transparent;
            }
        }

        .tracking-item .tracking-content {
            font-weight: 600;
            font-size: 17px;
        }

        .blinker {
            border: 7px solid #e9f8ea;
            animation: blink 1s;
            animation-iteration-count: infinite;
        }

        @keyframes blink {
            50% {
                border-color: #fff;
            }
        }
    </style>

    <!-- Hero Section Begin -->
    <section class="hero hero-normal">
        <div class="container">
            <div class="row">
                <div class="col-lg-3">
                    <?php
                    include "sections/categories.php";
                    ?>
                </div>
                <div class="col-lg-9">
                    <?php
                    include "sections/search.php";
                    ?>
                </div>
            </div>
        </div>
    </section>


    <!-- Hero Section End -->

    <!-- Breadcrumb Section Begin -->
    <section class="">
        <div class="container">
            <div class="row">
                <nav aria-label="breadcrumb">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a style="color: black !important;" href="./index.php" onmouseover="this.style.color='#225d2d'" onmouseout="this.style.color='black'">Home</a></li>
                        <li class="breadcrumb-item"><a style="color:#1877F2 !important;" href="#"> <b>Track Orders</b> </a></li>
                    </ol>
                </nav>

            </div>

            <div class="d-flex justify-content-between">
                <h5 class="mb-0"> <b> Total Items - <span id="order-count-badge" class="cart-count-badge"> 0 </span></b></h5>

            </div>

        </div>
    </section>
    <!-- Breadcrumb Section End -->



    <!-- Shoping Cart Section Begin -->
    <section class="shoping-cart spad">
        <div class="container" style="background-color: #eee;">
            <div class="row" id="orderdata">
                <div class="col-lg-12 mt-5">




                    <div class="row justify-content-between mx-4">
                        <button type="button" id="rateOrderBtn" class="btn custom-button2 btn-view" data-toggle="modal" data-target="#ratemodal" disabled>
                            RATE ORDER
                        </button>
                        <button type="button" id="ordernum" class="btn btn-main" data-toggle="modal" data-target="#exampleModalCenter" disabled>
                            VIEW HISTORY
                        </button>
                    </div>


                    <!--  modal structure -->
                    <div class="modal fade" id="ratemodal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
                        <div class="modal-dialog modal-dialog-centered" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title custom-color" id="ordernumber"><?php echo "Order ID: " . $_GET['orderid'] ?></h5>
                                    <hr>
                                    <h5 class="custom-color" id="ordertotal"></h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <div class="modal-body">
                                    <div id="errorMessages" style="color: red;"></div>
                                    <!-- Rating Form -->
                                    <form id="ratingForm">
                                        <div class="form-group">
                                            <label for="starRating">Star Rating:</label>


                                            <div class="star-rating">
                                                <i class="fa fa-star" data-rating="1"></i>
                                                <i class="fa fa-star" data-rating="2"></i>
                                                <i class="fa fa-star" data-rating="3"></i>
                                                <i class="fa fa-star" data-rating="4"></i>
                                                <i class="fa fa-star" data-rating="5"></i>
                                            </div>
                                            <input type="hidden" name="starRating" id="starRating" value="0" required>
                                            <input type="hidden" name="OrderID" id="OrderID" value="<?php echo $_GET['orderid']; ?>">
                                            <input type="hidden" name="userid" id="userid" value="<?php echo $userid; ?>">
                                        </div>
                                        <div class="form-group">
                                            <label for="feedbackMessage">Feedback Message:</label>
                                            <textarea id="feedbackMessage" name="feedbackMessage" rows="4" required></textarea>
                                        </div>
                                    </form>

                                </div>
                                <div class="modal-footer">
                                    <button type="button" id="submitrate" class="btn btn-main" onclick="submitRating()">Submit</button>
                                </div>
                            </div>
                        </div>
                    </div>





                    <!--track Modal -->
                    <div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
                        <div class="modal-dialog modal-dialog-centered" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title custom-color" id="ordernumber"><?php echo "Order ID: " . $_GET['orderid'] ?></h5>
                                    <hr>
                                    <h5 class="custom-color" id="ordertotal"></h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <div class="modal-body">
                                    <div id="tracking-pre"></div>
                                    <div id="tracking">
                                        <div class="tracking-list">
                                            <!--  tracking items will be added here dynamically with JavaScript -->
                                        </div>
                                    </div>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-main" data-dismiss="modal">Close</button>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>



                <div class="col-lg-12 mt-5 ml-4" id="useraddress" style="display: none;">
                    <h3 class="mb-1 custom-color">Delivery Address </h3>
                    <h5 id="deliveryaddress"></h5>

                </div>
            </div>
            <hr>

            <div class="col-lg-12 mt-5">
                <h3 class="mb-1 custom-color">Items in Order </h3>
                <div class="table-responsive">
                    <table class="table table-striped">
                        <thead>
                            <tr>
                                <th>Image</th>
                                <th>Description</th>
                                <th>Price</th>
                                <th>Quantity</th>
                                <th>SubTotal</th>
                                <th>Actions</th>

                            </tr>
                        </thead>
                        <tbody id="orderTableBody">
                            <!-- Order data will be inserted here dynamically -->
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        </div>
    </section>
    <!-- Shoping Cart Section End -->

    <!-- Footer Section Begin -->
    <?php
    include "includes/footer.php";
    ?>
    <!-- Footer Section End -->

    <script>
        $(document).ready(function() {

            fetchsingleorder();


        });

        var OrderID = <?php echo $_GET['orderid']; ?>;
        var userid = <?php echo $userid; ?>;
        var branchid = <?php echo $branchid; ?>;






        function fetchsingleorder() {

            $('#orderTableBody').html('<tr><td colspan="5"><i class="fa fa-spinner fa-spin fa-3x"></td></tr>');


            $.ajax({
                type: 'POST',
                url: 'functions/singleorder.php',
                data: {
                    userid: userid,
                    storeid: branchid,
                    orderid: OrderID


                },
                dataType: 'json',
                success: function(response) {

                    if (response && response.OrderID !== undefined && response.OrderID !== null && response.OrderID > 0) {
                        var data = response;

                        if (data.Delivered != 1) {
                            window.location.href = 'trackorder.php?orderid=' + data.OrderID;

                        } else {
                            updateorderdata(data);
                        }


                    } else {
                        var noOrderMessage =
                            '<div style="display: flex; flex-direction: column; align-items: center;">' +
                            '<div style="margin-bottom: 10px; margin-right:10px"><img src="img/norders.png" width="300" alt="No Order"></div>' +
                            '<h4 class="mb-3 mt-4">The specified order was not found.</h4>' +
                            '</div>';
                        $('#orderdata').html(noOrderMessage);
                    }


                },

            });
        }



        function updateorderdata(data) {
            const trackingList = document.querySelector('.tracking-list');
            let trackingData;


            if (data.DeliveryOption == "1") {
                trackingData = [{
                        status: 'Order Placed',
                        date: data.Date,
                        pending: (data.Date !== null) ? 0 : 1
                    },
                    {
                        status: 'Order Confirmed',
                        date: data.ConfirmedTime || 'Not Confirmed',
                        pending: (data.ConfirmedTime !== null) ? 0 : 1
                    },
                    {
                        status: 'Order Packed',
                        date: data.PackedTime || 'Not Packed',
                        pending: (data.PackedTime !== null) ? 0 : 1
                    },
                    {
                        status: 'Order Picked',
                        date: data.PickedTime || 'Not Picked',
                        pending: (data.PickedTime !== null) ? 0 : 1
                    },
                    {
                        status: 'Out for Delivery',
                        date: data.OnDeliveryTime || 'Not Out for Delivery',
                        pending: (data.OnDeliveryTime !== null) ? 0 : 1

                    },
                    {
                        status: 'Delivered',
                        date: data.DeliveredTime || 'Not Delivered',
                        pending: (data.DeliveredTime !== null) ? 0 : 1

                    }

                ];
            } else if (data.DeliveryOption == "2") {
                trackingData = [{
                        status: 'Order Placed',
                        date: data.Date,
                        pending: (data.Date !== null) ? 0 : 1
                    },
                    {
                        status: 'Order Confirmed',
                        date: data.ConfirmedTime || 'Not Confirmed',
                        pending: (data.ConfirmedTime !== null) ? 0 : 1
                    },
                    {
                        status: 'Order Packed',
                        date: data.PackedTime || 'Not Packed',
                        pending: (data.PackedTime !== null) ? 0 : 1
                    },
                    {
                        status: 'Order Picked',
                        date: data.PickedTime || 'Not Picked',
                        pending: (data.PickedTime !== null) ? 0 : 1
                    },
                    {
                        status: 'Delivered',
                        date: data.DeliveredTime || 'Not Delivered',
                        pending: (data.DeliveredTime !== null) ? 0 : 1

                    }

                ];
            }



            trackingList.innerHTML = '';

            trackingData.forEach((item, index) => {
                const trackingItem = document.createElement('div');

                if (item.pending == 1) {
                    trackingItem.classList.add('tracking-item-pending');

                } else {
                    trackingItem.classList.add('tracking-item');

                }



                const trackingIcon = document.createElement('div');
                trackingIcon.classList.add('tracking-icon', 'status-intransit');

                trackingIcon.innerHTML = '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="none" stroke="#fff" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-check-circle"><circle cx="12" cy="12" r="10" /><polyline points="16 8 10 14 8 12" /></svg>';

                const trackingDate = document.createElement('div');
                trackingDate.classList.add('tracking-date');
                trackingDate.innerHTML = '<img src="https://raw.githubusercontent.com/shajo/portfolio/a02c5579c3ebe185bb1fc085909c582bf5fad802/delivery.svg" class="img-responsive" alt="order-placed" />';

                const trackingContent = document.createElement('div');
                trackingContent.classList.add('tracking-content');
                trackingContent.innerHTML = `${item.status}<span>${item.date}</span>`;

                trackingItem.appendChild(trackingIcon);
                trackingItem.appendChild(trackingDate);
                trackingItem.appendChild(trackingContent);

                trackingList.appendChild(trackingItem);
            });



            var p = document.getElementById("ordertotal");
            if (p) {
                // Change the inner HTML
                p.innerHTML = "Order-Total: Ksh" + data.Total;
            }

            fetchOrdersitems();




            if (data.DeliveryOption == 1) {
                fetchdeliveryaddress();
            }

            if (data.feedbackid == null || data.feedbackid === undefined) {
                var button2 = document.getElementById("rateOrderBtn");
                if (button2) {
                    button2.disabled = false;
                }
                changeBackgroundColor();
                var message = "🌟 Your feedback matters! Please take a moment to rate your recent order. It helps us enhance our services. Thank you! 🌟";

                toastr.options.timeOut = 0;
                toastr.options.extendedTimeOut = 0;
                toastr.success(message);



            } else {
                var button2 = document.getElementById("rateOrderBtn");
                if (button2) {
                    button2.style.display = "none";
                }
            }
        }

        function fetchdeliveryaddress() {


            $.ajax({
                type: 'POST',
                url: 'functions/getdeliveryaddress.php',
                data: {
                    userid: userid,
                    orderid: OrderID


                },
                dataType: 'json',
                success: function(response) {

                    var useraddress = document.getElementById('useraddress');

                    // Set display property to "block"
                    useraddress.style.display = 'block';

                    $('#deliveryaddress').text(response.road + "/" + response.regionname + "/" + response.building);





                },

            });
        }






        function fetchOrdersitems() {
            var fetchOrderUrl = 'functions/orderdetails.php?userid=' + userid + '&OrderID=' + OrderID;

            var orderTableBody = $('#orderTableBody');
            orderTableBody.empty(); // Clear existing data


            orderTableBody.html('<tr><td colspan="5"><i class="fa fa-spinner fa-spin fa-3x"></td></tr>');


            $.ajax({
                type: 'GET',
                url: fetchOrderUrl,
                dataType: 'json',
                success: function(data) {
                    if (data.length > 0) {
                        updateOrdersData(data);
                        $('#order-count-badge').text(data.length);
                        var button = document.getElementById("ordernum");
                        if (button) {
                            button.disabled = false;
                        }

                    } else {



                    }

                },
                error: function(error) {
                    // console.error('Error fetching orders:', error);
                    // Handle error case
                }
            });
        }

        function numberWithCommas(x) {
            return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        }

        function updateOrdersData(data) {
            var orderTableBody = $('#orderTableBody');
            orderTableBody.empty(); // Clear existing data


            $.each(data, function(index, order) {
                // Format the total amount with currency symbol
                var formattedTotal = 'Ksh ' + numberWithCommas(order.Price);
                var total = order.Price * order.Quantity;


                var formatted_subTotal = 'Ksh ' + numberWithCommas(total.toFixed(2));


                var imageSrc = order.Image ? order.Image : 'img/noimage.jpg';

                
                var row = '<tr>' +
                    '<td>' +
                    '<img src="' + imageSrc + '" alt="Product Image" width="100">' +
                    '</td>' +
                    '<td>' +
                    '<h5>' + order.name + '</h5>' +
                    '</td>' +
                    '<td>' + formattedTotal + '</td>' +
                    '<td>' + order.Quantity + '</td>' +
                    '<td>' + formatted_subTotal + '</td>' +
                    '<td>' +
                    '<p style="display: none;" id="spinner-${order.ItemID}"> <i class="fa fa-spinner fa-spin fa-2x"></i> </p>'+
                    '<button class="btn btn-main add-to-cart-btn btn" data-itemid="${order.ItemID}" data-itemname="${order.name}" data-quantity="1" data-type="product">' +
                    '<a><i class="fa fa-shopping-cart"></i> Add to cart</a>' +
                    
                    '</button>' +
                    '</td>' +
                    '</tr>';


                   


                orderTableBody.append(row);
            });



        }

        function changeBackgroundColor() {
            var button = document.getElementById('rateOrderBtn');
            var color1 = 'var(--main2-color)';
            var color2 = 'var(--main-color)';
            var currentColor = color1;

            setInterval(function() {
                button.style.backgroundColor = currentColor;
                currentColor = (currentColor === color1) ? color2 : color1;
            }, 3000);
        }



        // JavaScript to handle star rating selection
        document.addEventListener('DOMContentLoaded', function() {
            var stars = document.querySelectorAll('.star-rating i');

            stars.forEach(function(star) {
                star.addEventListener('click', function() {
                    var rating = this.getAttribute('data-rating');
                    document.getElementById('starRating').value = rating;

                    // Change the color of selected stars
                    for (var i = 0; i < stars.length; i++) {
                        if (i < rating) {
                            stars[i].classList.add('rated');
                        } else {
                            stars[i].classList.remove('rated');
                        }
                    }
                });
            });
        });

        // JavaScript function to handle form submission
        function submitRating() {
            // Access the form elements and submit the data to your server using AJAX
            var starRating = document.getElementById('starRating').value;
            var feedbackMessage = document.getElementById('feedbackMessage').value;
            var OrderID = document.getElementById('OrderID').value;
            var userid = document.getElementById('userid').value;




            var errorMessagesDiv = document.getElementById('errorMessages');

            // Reset error messages
            errorMessagesDiv.innerHTML = '';

            // Check if the star rating is selected
            if (starRating == 0) {
                errorMessagesDiv.innerHTML = "Please select a star rating before submitting.";
                return;
            }

            // Check if the feedback message is not empty
            if (feedbackMessage.trim() === '') {
                errorMessagesDiv.innerHTML = "Please provide a feedback message before submitting.";
                return;
            }

            var myButton = document.getElementById("submitrate");

            // Disable the button
            myButton.disabled = true;

            // Change the inner HTML to "submitrate"
            myButton.innerHTML = "Processing";

            toastr.clear();



            $.ajax({
                type: 'POST',
                url: 'functions/postfeedback.php',
                data: {
                    starRating,
                    feedbackMessage,
                    OrderID,
                    userid


                },
                dataType: 'json',
                success: function(response) {

                    var message = response.message;

                    if (response.success == true) {

                        toastr.options.timeOut = 3000;
                        toastr.success("Thank you for your feedback! We appreciate your input.");

                        var button2 = document.getElementById("rateOrderBtn");
                        if (button2) {
                            button2.style.display = "none";
                        }

                    } else {

                        toastr.options.timeOut = 3000;
                        toastr.error(message);
                    }




                    $('#ratemodal').modal('hide');

                    // Disable the button
                    myButton.disabled = false;

                    // Change the inner HTML to "submitrate"
                    myButton.innerHTML = "Submit";


                },


            });


        }
    </script>



</body>

</html>